--[[
	A very simple "Lovegirl Settings" Manager

	Loads values form cac_settings-files as tables and also saves them

	by Matthias Weiß <info@codeandcreate.de>
--]]

local cac_settings = {};
local settingsDrawer = "sys:settings/"

function cac_settings.load(fileName)
    t = {}
    loadedSettings = fs.read(settingsDrawer .. fileName .. ".settings")
	settingsToPase = loadedSettings or ""
    for k, v in string.gmatch(settingsToPase, "([%w%p]*)=([%w%p]*)") do
		t[k] = v
    end
    return t
end

function cac_settings.save(fileName, settingsArray)
	datatosave = ""
	for key,value in pairs(settingsArray) do
		datatosave = datatosave .. key .. "=" .. value .. "\n"
	end
	fs.write(settingsDrawer .. fileName .. ".settings", datatosave)
end

return cac_settings