local Window, dialog, ui, hgSettings, widget = 
	require("window"),
	require("dialog"),
	require("ui"),
	require("cac_settings"),
	require("widget")
local win
local settings = hgSettings.load("Startup")
local workbenchSettings = hgSettings.load("Workbench")

function _init()

	win_w = 320
	win_h = 120
	win_position_l = 320 - (win_w / 2)
	win_position_t = 180 - (win_h / 2)

	if workbenchSettings.screenSize == "11" then
		win_position_t = 90 - (win_h / 2)
	end

	win = Window:new("Preferences: Network drive", win_position_l, win_position_t, win_w, win_h)
	win.resizable = false
	win.onclose = function()
		sys.exit()
	end

	lineTop = 4;
	lineLeft = 4;

	-- default net drive

	local label_mount_world = win:attach("label_mount_world", ui.Label:new("Mount \"world\":"))
	local label_mount_world_w, label_mount_world_h = label_mount_world:autosize()
	label_mount_world:position(lineLeft, lineTop + 4)

	btn_mount_world = win:attach("btn_mount_world", ui.Button:new(" "))
	btn_mount_world_w, btn_mount_world_h = btn_mount_world:autosize()
	if settings.mounthomegirlzone == "1" then
		btn_mount_world.label = "X"
		btn_mount_world.bgcolor = 6
	end
	btn_mount_world.onclick = function()
		if btn_mount_world.label == "X" then
			settings.mounthomegirlzone = "0"
			btn_mount_world.label = " "
			btn_mount_world.bgcolor = win.bgcolor
		else
			settings.mounthomegirlzone = "1"
			btn_mount_world.label = "X"
			btn_mount_world.bgcolor = 6
		end
	end
	btn_mount_world:position(win_w - (btn_mount_world_w + 12), lineTop)

	lineTop = lineTop + label_mount_world_h + 12;

	-- custom network drive

	local label_custom_net_name = win:attach("label_custom_net_name", ui.Label:new("Custom network drive name:"))
	local label_custom_net_name_w, label_custom_net_name_h = label_custom_net_name:autosize()
	label_custom_net_name:position(lineLeft, lineTop)
	lineTop = lineTop + label_custom_net_name_h;

	btn_custom_net_name = win:attach("btn_custom_net_name", ui.TextInput:new())
	btn_custom_net_name:setcontent(settings.customnetfsname)
	btn_custom_net_name:position(lineLeft, lineTop)
	btn_custom_net_name:size(win_w - (lineLeft + 12), 12);
	btn_custom_net_name.scrollx = 0
	lineTop = lineTop + 20;


	local label_custom_net_uri = win:attach("label_custom_net_uri", ui.Label:new("Custom network drive uri:"))
	local label_custom_net_uri_w, label_custom_net_uri_h = label_custom_net_uri:autosize()
	label_custom_net_uri:position(lineLeft, lineTop)
	lineTop = lineTop + label_custom_net_uri_h;

	btn_custom_net_uri = win:attach("btn_custom_net_uri", ui.TextInput:new(settings.customnetfsuri))
	btn_custom_net_uri:setcontent(settings.customnetfsuri)
	btn_custom_net_uri:position(lineLeft, lineTop)
	btn_custom_net_uri:size(win_w - (lineLeft + 12), 12);
	btn_custom_net_uri.scrollx = 0

	-- Show Memory:
	--[[
	

--]]
	-- Save:
	btn_save = win:attach("button_save", ui.Button:new("Save"))
	btn_save_w, btn_save_h = btn_save:autosize()
	btn_save.bgcolor = 5
	btn_save.onclick = function()

		settings.customnetfsname = btn_custom_net_name.content
		settings.customnetfsuri = btn_custom_net_uri.content

		hgSettings.save("Startup", settings)
		alertWindow = win:attach(
			"save_dialog",
			dialog.Alert:new(
				"Preferences saved",
				"Please restart Homegirl..."
			)
		)
		alertWindow.ondone = function()
			sys.exit()
		end
	end
	btn_save:position(win_w - (btn_save_w + 12), win_h - (btn_save_h + 16))

	sys.stepinterval(-1)
end
function _step(t)
  win:step(t)
  sys.stepinterval(sys.stepinterval() * -1)
end
