local Window, dialog, ui, filerequester, hgSettings, widget = 
	require("window"),
	require("dialog"),
	require("ui"),
	require("cac_filedialog"),
	require("cac_settings"),
	require("widget")
local win
local settings = hgSettings.load("Workbench")

function _init()

	win_w = 240
	win_h = 100
	win_position_l = 320 - (win_w / 2)
	win_position_t = 180 - (win_h / 2)

	if settings.screenSize == "11" then
		win_position_t = 90 - (win_h / 2)
	end

	win = Window:new("Preferences: Workbench", win_position_l, win_position_t, win_w, win_h)
	win.resizable = false
	win.onclose = function()
		sys.exit()
	end

	lineTop = 4;

	-- Backdrop:

	local label_bd = win:attach("label_bd", ui.Label:new("Change Backdrop: "))
	local label_bd_w, label_bd_h = label_bd:autosize()
	label_bd:position(4, lineTop + 4)

	btn_change_bd = win:attach("button_change_bd", ui.Button:new("Select..."))
	btn_change_bd_w, btn_change_bd_h = btn_change_bd:autosize()
	btn_change_bd.onclick = function()
		local req = win:attach("filerequest", filerequester:new("Change Backdrop to..", {".gif"}, settings.backdrop .. "/../"))
		req.ondone = function(filename)
			if filename then
				settings.backdrop = filename
			end
		end
	end

	btn_change_bd:position(win_w - (btn_change_bd_w + 12), lineTop)
	
	lineTop = lineTop + label_bd_h + 8;

	-- screenSize:

	local label_ds = win:attach("label_ds", ui.Label:new("Desktop size: "))
	local label_ds_w, label_ds_h = label_ds:autosize()
	label_ds:position(4, lineTop + 4)

	btn_ds_12 = win:attach("button_screensize_11", ui.Button:new("1:2"))
	btn_ds_12_w, btn_ds_12_h = btn_ds_12:autosize()
	if settings.screenSize == "11" then
		btn_ds_12.bgcolor = 6
	end
	btn_ds_12.onclick = function()
		settings.screenSize = "11"
		btn_ds_12.bgcolor = 6
		btn_ds_11.bgcolor = win.bgcolor
		btn_ds_12:redraw()
		btn_ds_11:redraw()
	end

	btn_ds_11 = win:attach("button_screensize_15", ui.Button:new("1:1"))
	btn_ds_11_w, btn_ds_11_h = btn_ds_11:autosize()
	if settings.screenSize == "31" then
		btn_ds_11.bgcolor = 6
	end
	btn_ds_11.onclick = function()
		settings.screenSize = "31"
		btn_ds_12.bgcolor = win.bgcolor
		btn_ds_11.bgcolor = 6
		btn_ds_12:redraw()
		btn_ds_11:redraw()
	end

	btn_ds_12:position(win_w - (btn_ds_12_w + 12), lineTop)
	btn_ds_11:position(win_w - (btn_ds_12_w + btn_ds_11_w + 12), lineTop)
	
	lineTop = lineTop + label_ds_h + 8;

	-- Show Memory:

	local label_sm = win:attach("label_sm", ui.Label:new("Free memory visible: "))
	local label_sm_w, label_sm_h = label_sm:autosize()
	label_sm:position(4, lineTop + 4)


	btn_sm = win:attach("button_sm", ui.Button:new(" "))
	btn_sm_w, btn_sm_h = btn_sm:autosize()
	if settings.showMemory == "1" then
		btn_sm.label = "X"
		btn_sm.bgcolor = 6
	end
	btn_sm.onclick = function()
		if btn_sm.label == "X" then
			settings.showMemory = "0"
			btn_sm.label = " "
			btn_sm.bgcolor = win.bgcolor
		else
			settings.showMemory = "1"
			btn_sm.label = "X"
			btn_sm.bgcolor = 6
		end
	end
	btn_sm:position(win_w - (btn_sm_w + 12), lineTop)

	lineTop = lineTop + label_sm_h + 8;

	-- Save:

	btn_save = win:attach("button_save", ui.Button:new("Save"))
	btn_save_w, btn_save_h = btn_save:autosize()
	btn_save.bgcolor = 5
	btn_save.onclick = function()
		hgSettings.save("Workbench", settings)
		alertWindow = win:attach(
			"save_dialog",
			dialog.Alert:new(
				"Preferences saved",
				"Please restart Homegirl..."
			)
		)
		alertWindow.ondone = function()
			sys.exit()
		end
	end
	btn_save:position(win_w - (btn_save_w + 12), win_h - (btn_save_h + 16))

	sys.stepinterval(-1)
end
function _step(t)
  win:step(t)
  sys.stepinterval(sys.stepinterval() * -1)
end
