local Window, dialog, ui, hgSettings, widget = 
	require("window"),
	require("dialog"),
	require("ui"),
	require("cac_settings"),
	require("widget")
local win
local settings = hgSettings.load("Startup")
local workbenchSettings = hgSettings.load("Workbench")

function _init()

	win_w = 240
	win_h = 80
	win_position_l = 320 - (win_w / 2)
	win_position_t = 180 - (win_h / 2)

	if workbenchSettings.screenSize == "11" then
		win_position_t = 90 - (win_h / 2)
	end

	win = Window:new("Preferences: WPM", win_position_l, win_position_t, win_w, win_h)
	win.resizable = false
	win.onclose = function()
		sys.exit()
	end

	lineTop = 4;
	lineLeft = 4;

	-- Workspace Manager:

	local label_wpm = win:attach("label_wpm", ui.Label:new("Select workspace manager:"))
	local label_wpm_w, label_wpm_h = label_wpm:autosize()
	label_wpm:position(lineLeft, lineTop)

	lineTop = lineTop + label_wpm_h + 4;

	btn_workshop = win:attach("button_workshop", ui.Button:new(" "))
	btn_workshop_w, btn_workshop_h = btn_workshop:autosize()
	if settings.workspacemanager == "/cmd/workshop.lua" then
		btn_workshop.bgcolor = 6
		btn_workshop.label = "X"
	end
	btn_workshop.onclick = function()
		settings.workspacemanager = "/cmd/workshop.lua"
		btn_workshop.bgcolor = 6
		btn_workshop.label = "X"
		btn_workbench.bgcolor = win.bgcolor
		btn_workbench.label = " "
		btn_workshop:redraw()
		btn_workbench:redraw()
	end
	btn_workshop:position(lineLeft, lineTop)

	local label_wpm_workshop = win:attach("label_wpm_workshop", ui.Label:new("Workshop"))
	local label_wpm_workshop_w, label_wpm_workshop_h = label_wpm_workshop:autosize()
	label_wpm_workshop:position(btn_workshop_w + 12, lineTop + 4)

	lineTop = lineTop + label_wpm_workshop_h + 8;

	btn_workbench = win:attach("button_workbench", ui.Button:new(" "))
	btn_workbench_w, btn_workbench1_h = btn_workbench:autosize()
	if settings.workspacemanager == "/cmd/cac_workbench.lua" then
		btn_workbench.bgcolor = 6
		btn_workbench.label = "X"
	end
	btn_workbench.onclick = function()
		settings.workspacemanager = "/cmd/cac_workbench.lua"
		btn_workshop.bgcolor = win.bgcolor
		btn_workshop.label = " "
		btn_workbench.bgcolor = 6
		btn_workbench.label = "X"
		btn_workshop:redraw()
		btn_workbench:redraw()
	end
	btn_workbench:position(lineLeft, lineTop)

	local label_wpm_workbench = win:attach("label_wpm_workbench", ui.Label:new("Workbench"))
	local label_wpm_workbench_w, label_wpm_workbench_h = label_wpm_workbench:autosize()
	label_wpm_workbench:position(btn_workbench_w + 12, lineTop + 4)
	
	

	-- Show Memory:
	--[[
	

--]]
	-- Save:
	btn_save = win:attach("button_save", ui.Button:new("Save"))
	btn_save_w, btn_save_h = btn_save:autosize()
	btn_save.bgcolor = 5
	btn_save.onclick = function()
		hgSettings.save("Startup", settings)
		alertWindow = win:attach(
			"save_dialog",
			dialog.Alert:new(
				"Preferences saved",
				"Please restart Homegirl..."
			)
		)
		alertWindow.ondone = function()
			sys.exit()
		end
	end
	btn_save:position(win_w - (btn_save_w + 12), win_h - (btn_save_h + 16))

	sys.stepinterval(-1)
end
function _step(t)
  win:step(t)
  sys.stepinterval(sys.stepinterval() * -1)
end
